#ifndef __BE_FTP_APP__

#include <Application.h>
#include <String.h>
#include <Entry.h>

#include "BeFTPWindow.h"

class BeFTPApp : public BApplication
{
public:
	BeFTPApp (const char * a_app_sig);
	~BeFTPApp (void);

	virtual void	ReadyToRun		(void);
	virtual void	ArgvReceived	(int32 argc, char **argv);
	virtual	void	MessageReceived	(BMessage * a_message);
	virtual	void	AboutRequested	(void);

private:
	void			GetPreferences	(void);	
	void 			ProcessRefs		(BMessage	*	a_message);
	void 			RunScript		(void);
	void			NameSafe		(BString * a_string);
	void			FullQuote		(BString * a_string);
	void			Help			(void);
	status_t		CreateTempFolder	(void);

	bool	argv_received;
	
	BDirectory		*	m_tmp_dir;
	BFWindow		*	m_window;

	entry_ref	m_app_ref;	
	BString		m_dir;
	BString		m_command;
	bool		m_keep_open;
	bool		m_in_terminal;
};

#define __BE_FTP_APP__
#endif
