//// EditView.cpp
//

#define DEBUG 0
#include <Debug.h>

#include <Application.h>
#include <Roster.h>
#include <Window.h>
#include <Box.h>
#include <TextControl.h>
#include <Button.h>
#include <CheckBox.h>
#include <Node.h>
#include <NodeInfo.h>
#include <Bitmap.h>
#include <String.h>
#include <Beep.h>
#include <fs_attr.h>


#include "BeTelnetDefs.h"
#include "EditView.h"

EditView::EditView(entry_ref a_ref)
: BBox(BRect(5,5,330,100), "EditView", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS)	
{
	m_ref	=	a_ref;

//	float str_width	=	StringWidth("Local dir");

//	m_dir		=	new BTextControl(BRect(5,60,318,80), "Local dir", "Local dir", "", NULL, B_FOLLOW_LEFT_RIGHT);
//	m_dir->			SetDivider(str_width-5);

//	AddChild(m_dir);
}

void 
EditView::AllAttached	(void)
{
	Init();
}

void 
EditView::Draw	(BRect updateRect)	
{
	SetHighColor(Parent()->ViewColor());
	FillRect(updateRect);

	SetHighColor(0,0,0);

	float str_width		=	StringWidth("Working dir");
	float str_height	=	StringWidth("W");
	float name_width	=	StringWidth(m_ref.name);

	
	MovePenTo((str_width + (Bounds().Width()-(str_width))/2 - (name_width/2) - 7),
				(46 - 15 + (str_height/2) - 1));

	DrawString(m_ref.name);

	SetDrawingMode(B_OP_OVER);
	
	if (m_bitmap != NULL)
		DrawBitmap(m_bitmap, BRect((str_width/2-15), 15, (str_width/2+16), 46));
	else
	{
		// Grey fill
		SetHighColor(Parent()->ViewColor());
		FillRect(BRect((str_width/2-15), 15, (str_width/2+16), 46));
	}

	BBox::Draw(updateRect);
}

void 
EditView::FrameResized	(float width, float height)	
{
	BBox::FrameResized(width, height);

	Draw(Bounds());
}

EditView::~EditView()	
{
	delete m_bitmap;
}

void 
EditView::MessageReceived(BMessage * a_message)
{
	switch(a_message->what)
	{
		// not much to do around here
		
		default:
				BBox::MessageReceived(a_message);
			break;			
	}
}

void 
EditView::Save	(void)
{
/*
	BNode		node		(& m_ref);
	off_t		bytes	=	0;	
	
	BString	dir		=	m_dir->Text();
	
	if (dir.Length() != 0)
	{
		bytes = node.WriteAttr("beftp:dir", B_STRING_TYPE, 0, dir.String(), dir.Length()+1);
		if (! bytes == dir.Length()+1)
			beep();
	}
	else
		node.RemoveAttr("beftp:dir");
*/
}

void 
EditView::Init	(void)
{
	BNode		node		(& m_ref);
	BNodeInfo	nodeinfo	(& node);
	
	m_bitmap	=	new BBitmap	(BRect(0,0,31,31), B_COLOR_8_BIT, true);
		
	if (BNodeInfo::GetTrackerIcon(& m_ref, m_bitmap, B_LARGE_ICON) != B_OK)
		m_bitmap = NULL;
/*
	char * buffer	=	new char [4096];
	off_t	bytes	=	0;
	
	bytes = node.ReadAttr("beftp:dir", B_STRING_TYPE, 0, buffer, 4095);
	if (bytes >= 0)
	{
		buffer[bytes] = '\0';
		m_dir->SetText(buffer);
	}
	
	delete [] buffer;
*/
}
